Loading...
Searching...
No Matches
UFF/AngleConstraint.h
Go to the documentation of this file.
//
// Copyright (C) 2013 Paolo Tosco
//
// Copyright (C) 2004-2006 Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#include <RDGeneral/export.h>
#ifndef __RD_UFFANGLECONSTRAINT_H__
#define __RD_UFFANGLECONSTRAINT_H__
#include <iostream>
#include <ForceField/Contrib.h>
namespace ForceFields {
namespace UFF {
//! An angle range constraint modelled after a AngleBendContrib
class RDKIT_FORCEFIELD_EXPORT AngleConstraintContrib
: public ForceFieldContrib {
public:
AngleConstraintContrib() {}
//! Constructor
/*!
\param owner pointer to the owning ForceField
\param idx1 index of atom1 in the ForceField's positions
\param idx2 index of atom2 in the ForceField's positions
\param idx3 index of atom3 in the ForceField's positions
\param minAngle minimum angle
\param maxAngle maximum angle
\param forceConst force Constant
*/
AngleConstraintContrib(ForceField *owner, unsigned int idx1,
unsigned int idx2, unsigned int idx3,
double minAngleDeg, double maxAngleDeg,
double forceConst);
AngleConstraintContrib(ForceField *owner, unsigned int idx1,
unsigned int idx2, unsigned int idx3, bool relative,
double minAngleDeg, double maxAngleDeg,
double forceConst);
~AngleConstraintContrib() override = default;
double getEnergy(double *pos) const override;
void getGrad(double *pos, double *grad) const override;
AngleConstraintContrib *copy() const override {
return new AngleConstraintContrib(*this);
}
private:
double computeAngleTerm(double angle) const;
int d_at1Idx{-1}, d_at2Idx{-1},
d_at3Idx{-1}; //!< indices of atoms forming the angle
double d_minAngleDeg, d_maxAngleDeg; //!< rest amplitudes of the angle
double d_forceConstant; //!< force constant of the angle constraint
};
} // namespace UFF
} // namespace ForceFields
#endif
Contrib.h
ForceFields::ForceFieldContrib
abstract base class for contributions to ForceFields
Definition Contrib.h:18
ForceFields::ForceField
A class to store forcefields and handle minimization.
Definition ForceField.h:79
ForceFields::UFF::AngleConstraintContrib
An angle range constraint modelled after a AngleBendContrib.
Definition UFF/AngleConstraint.h:23
ForceFields::UFF::AngleConstraintContrib::getEnergy
double getEnergy(double *pos) const override
returns our contribution to the energy of a position
ForceFields::UFF::AngleConstraintContrib::~AngleConstraintContrib
~AngleConstraintContrib() override=default
ForceFields::UFF::AngleConstraintContrib::getGrad
void getGrad(double *pos, double *grad) const override
calculates our contribution to the gradients of a position
ForceFields::UFF::AngleConstraintContrib::AngleConstraintContrib
AngleConstraintContrib()
Definition UFF/AngleConstraint.h:25
ForceFields::UFF::AngleConstraintContrib::AngleConstraintContrib
AngleConstraintContrib(ForceField *owner, unsigned int idx1, unsigned int idx2, unsigned int idx3, bool relative, double minAngleDeg, double maxAngleDeg, double forceConst)
ForceFields::UFF::AngleConstraintContrib::AngleConstraintContrib
AngleConstraintContrib(ForceField *owner, unsigned int idx1, unsigned int idx2, unsigned int idx3, double minAngleDeg, double maxAngleDeg, double forceConst)
Constructor.
ForceFields::UFF::AngleConstraintContrib::copy
AngleConstraintContrib * copy() const override
return a copy
Definition UFF/AngleConstraint.h:51
export.h
RDKIT_FORCEFIELD_EXPORT
#define RDKIT_FORCEFIELD_EXPORT
Definition export.h:185
ForceFields
Definition TorsionAngleM6.h:22